diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/model/simple-ofdm-wimax-phy.cc ns-3.42/src/wimax/model/simple-ofdm-wimax-phy.cc
--- ns-3.41/src/wimax/model/simple-ofdm-wimax-phy.cc	2024-02-09 14:44:08.625795400 -0800
+++ ns-3.42/src/wimax/model/simple-ofdm-wimax-phy.cc	2024-05-29 15:29:47.224074000 -0700
@@ -36,6 +36,7 @@
 
 #include <cmath>
 #include <string>
+#include <vector>
 
 namespace ns3
 {
@@ -536,31 +537,29 @@
 Ptr<PacketBurst>
 SimpleOfdmWimaxPhy::ConvertBitsToBurst(Bvec buffer)
 {
-    uint8_t init[buffer.size() / 8];
-    uint8_t* pstart = init;
-    uint8_t temp;
+    const auto bufferSize = buffer.size() / 8;
+    std::vector<uint8_t> bytes(bufferSize, 0);
     int32_t j = 0;
     // recreating byte buffer from bit buffer (Bvec)
-    for (uint32_t i = 0; i < buffer.size(); i += 8)
+    for (std::size_t i = 0; i < buffer.size(); i += 8)
     {
-        temp = 0;
-        for (int l = 0; l < 8; l++)
+        uint8_t temp = 0;
+        for (std::size_t l = 0; l < 8; l++)
         {
             bool bin = buffer.at(i + l);
             temp |= (bin << (7 - l));
         }
 
-        *(pstart + j) = temp;
+        bytes[j] = temp;
         j++;
     }
-    uint16_t bufferSize = buffer.size() / 8;
     uint16_t pos = 0;
     Ptr<PacketBurst> RecvBurst = Create<PacketBurst>();
     while (pos < bufferSize)
     {
         uint16_t packetSize = 0;
         // Get the header type: first bit
-        uint8_t ht = (pstart[pos] >> 7) & 0x01;
+        uint8_t ht = (bytes[pos] >> 7) & 0x01;
         if (ht == 1)
         {
             // BW request header. Size is always 8 bytes
@@ -569,15 +568,15 @@
         else
         {
             // Read the size
-            uint8_t Len_MSB = pstart[pos + 1] & 0x07;
-            packetSize = (uint16_t)((uint16_t)(Len_MSB << 8) | (uint16_t)(pstart[pos + 2]));
+            uint8_t Len_MSB = bytes[pos + 1] & 0x07;
+            packetSize = (uint16_t)((uint16_t)(Len_MSB << 8) | (uint16_t)(bytes[pos + 2]));
             if (packetSize == 0)
             {
                 break; // padding
             }
         }
 
-        Ptr<Packet> p = Create<Packet>(&(pstart[pos]), packetSize);
+        Ptr<Packet> p = Create<Packet>(&bytes[pos], packetSize);
         RecvBurst->AddPacket(p);
         pos += packetSize;
     }
@@ -786,20 +785,14 @@
         blockSize = 24;
         break;
     case MODULATION_TYPE_QPSK_12:
-        blockSize = 48;
-        break;
     case MODULATION_TYPE_QPSK_34:
         blockSize = 48;
         break;
     case MODULATION_TYPE_QAM16_12:
-        blockSize = 96;
-        break;
     case MODULATION_TYPE_QAM16_34:
         blockSize = 96;
         break;
     case MODULATION_TYPE_QAM64_23:
-        blockSize = 144;
-        break;
     case MODULATION_TYPE_QAM64_34:
         blockSize = 144;
         break;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/model/ss-link-manager.cc ns-3.42/src/wimax/model/ss-link-manager.cc
--- ns-3.41/src/wimax/model/ss-link-manager.cc	2024-02-09 14:44:08.625795400 -0800
+++ ns-3.42/src/wimax/model/ss-link-manager.cc	2024-05-29 15:29:47.224074000 -0700
@@ -377,7 +377,7 @@
     }
 
     m_nrRngRspsRecvd++;
-    if (m_waitForRngRspEvent.IsRunning())
+    if (m_waitForRngRspEvent.IsPending())
     {
         Simulator::Cancel(m_waitForRngRspEvent);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/model/ss-net-device.cc ns-3.42/src/wimax/model/ss-net-device.cc
--- ns-3.41/src/wimax/model/ss-net-device.cc	2024-02-09 14:44:08.625795400 -0800
+++ ns-3.42/src/wimax/model/ss-net-device.cc	2024-05-29 15:29:47.224074000 -0700
@@ -854,7 +854,7 @@
                     Simulator::Cancel(m_linkManager->GetDlMapSyncTimeoutEvent());
                 }
 
-                if (m_lostDlMapEvent.IsRunning())
+                if (m_lostDlMapEvent.IsPending())
                 {
                     Simulator::Cancel(m_lostDlMapEvent);
                 }
@@ -864,7 +864,7 @@
                                                        false,
                                                        m_lostDlMapEvent);
 
-                if (m_dcdWaitTimeoutEvent.IsRunning())
+                if (m_dcdWaitTimeoutEvent.IsPending())
                 {
                     Simulator::Cancel(m_dcdWaitTimeoutEvent);
                 }
@@ -874,7 +874,7 @@
                                                        false,
                                                        m_dcdWaitTimeoutEvent);
 
-                if (m_ucdWaitTimeoutEvent.IsRunning())
+                if (m_ucdWaitTimeoutEvent.IsPending())
                 {
                     Simulator::Cancel(m_ucdWaitTimeoutEvent);
                 }
@@ -890,7 +890,7 @@
                 break;
             }
             case ManagementMessageType::MESSAGE_TYPE_UL_MAP: {
-                if (m_lostUlMapEvent.IsRunning())
+                if (m_lostUlMapEvent.IsPending())
                 {
                     Simulator::Cancel(m_lostUlMapEvent);
                     m_linkManager->ScheduleScanningRestart(m_lostUlMapInterval,
@@ -908,7 +908,7 @@
                 {
                     if (m_linkManager->GetRangingIntervalFound())
                     {
-                        if (m_rangOppWaitTimeoutEvent.IsRunning())
+                        if (m_rangOppWaitTimeoutEvent.IsPending())
                         {
                             Simulator::Cancel(m_rangOppWaitTimeoutEvent);
                         }
@@ -923,7 +923,7 @@
                     SetState(SS_STATE_ACQUIRING_PARAMETERS);
                 }
 
-                if (m_dcdWaitTimeoutEvent.IsRunning())
+                if (m_dcdWaitTimeoutEvent.IsPending())
                 {
                     Simulator::Cancel(m_dcdWaitTimeoutEvent);
                     m_linkManager->ScheduleScanningRestart(m_intervalT1,
@@ -950,7 +950,7 @@
 
                 ProcessUcd(ucd);
 
-                if (m_ucdWaitTimeoutEvent.IsRunning())
+                if (m_ucdWaitTimeoutEvent.IsPending())
                 {
                     Simulator::Cancel(m_ucdWaitTimeoutEvent);
                     m_linkManager->ScheduleScanningRestart(m_intervalT12,
@@ -1029,10 +1029,8 @@
             {
             case ManagementMessageType::MESSAGE_TYPE_REG_REQ:
                 // not yet implemented
-                break;
             case ManagementMessageType::MESSAGE_TYPE_REG_RSP:
                 // intended for base station, ignore
-                break;
             case ManagementMessageType::MESSAGE_TYPE_DSA_REQ:
                 /*from other station as DSA initiation
                  by BS is not supported, ignore*/
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/model/ss-service-flow-manager.cc ns-3.42/src/wimax/model/ss-service-flow-manager.cc
--- ns-3.41/src/wimax/model/ss-service-flow-manager.cc	2024-02-09 14:44:08.625795400 -0800
+++ ns-3.42/src/wimax/model/ss-service-flow-manager.cc	2024-05-29 15:29:47.224074000 -0700
@@ -182,7 +182,7 @@
     m_dsaReqRetries++;
     p->AddHeader(ManagementMessageType(ManagementMessageType::MESSAGE_TYPE_DSA_REQ));
 
-    if (m_dsaRspTimeoutEvent.IsRunning())
+    if (m_dsaRspTimeoutEvent.IsPending())
     {
         Simulator::Cancel(m_dsaRspTimeoutEvent);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/model/wimax-tlv.cc ns-3.42/src/wimax/model/wimax-tlv.cc
--- ns-3.41/src/wimax/model/wimax-tlv.cc	2024-02-09 14:44:08.625795400 -0800
+++ ns-3.42/src/wimax/model/wimax-tlv.cc	2024-05-29 15:29:47.228073800 -0700
@@ -438,19 +438,12 @@
             break;
         }
         case ARQ_RETRY_TIMEOUT_Transmitter_Delay:
-            break;
         case ARQ_RETRY_TIMEOUT_Receiver_Delay:
-            break;
         case ARQ_BLOCK_LIFETIME:
-            break;
         case ARQ_SYNC_LOSS:
-            break;
         case ARQ_DELIVER_IN_ORDER:
-            break;
         case ARQ_PURGE_TIMEOUT:
-            break;
         case ARQ_BLOCK_SIZE:
-            break;
         case reserved2:
             break;
         case CS_Specification: {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/test/mac-messages-test.cc ns-3.42/src/wimax/test/mac-messages-test.cc
--- ns-3.41/src/wimax/test/mac-messages-test.cc	2024-02-09 14:44:08.625795400 -0800
+++ ns-3.42/src/wimax/test/mac-messages-test.cc	2024-05-29 15:29:47.228073800 -0700
@@ -123,9 +123,9 @@
 };
 
 Ns3WimaxMacMessagesTestSuite::Ns3WimaxMacMessagesTestSuite()
-    : TestSuite("wimax-mac-messages", UNIT)
+    : TestSuite("wimax-mac-messages", Type::UNIT)
 {
-    AddTestCase(new DsaRequestTestCase, TestCase::QUICK);
+    AddTestCase(new DsaRequestTestCase, TestCase::Duration::QUICK);
 }
 
 static Ns3WimaxMacMessagesTestSuite ns3WimaxMacMessagesTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/test/phy-test.cc ns-3.42/src/wimax/test/phy-test.cc
--- ns-3.41/src/wimax/test/phy-test.cc	2024-02-09 14:44:08.625795400 -0800
+++ ns-3.42/src/wimax/test/phy-test.cc	2024-05-29 15:29:47.228073800 -0700
@@ -188,10 +188,10 @@
 };
 
 Ns3WimaxPhyTestSuite::Ns3WimaxPhyTestSuite()
-    : TestSuite("wimax-phy-layer", UNIT)
+    : TestSuite("wimax-phy-layer", Type::UNIT)
 {
-    AddTestCase(new Ns3WimaxSNRtoBLERTestCase, TestCase::QUICK);
-    AddTestCase(new Ns3WimaxSimpleOFDMTestCase, TestCase::QUICK);
+    AddTestCase(new Ns3WimaxSNRtoBLERTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new Ns3WimaxSimpleOFDMTestCase, TestCase::Duration::QUICK);
 }
 
 static Ns3WimaxPhyTestSuite ns3WimaxPhyTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/test/qos-test.cc ns-3.42/src/wimax/test/qos-test.cc
--- ns-3.41/src/wimax/test/qos-test.cc	2024-02-09 14:44:08.625795400 -0800
+++ ns-3.42/src/wimax/test/qos-test.cc	2024-05-29 15:29:47.228073800 -0700
@@ -311,10 +311,10 @@
 };
 
 Ns3WimaxQoSTestSuite::Ns3WimaxQoSTestSuite()
-    : TestSuite("wimax-qos", SYSTEM)
+    : TestSuite("wimax-qos", Type::SYSTEM)
 {
-    AddTestCase(new Ns3WimaxSFTypeTestCase, TestCase::QUICK);
-    AddTestCase(new Ns3WimaxSchedulingTestCase, TestCase::QUICK);
+    AddTestCase(new Ns3WimaxSFTypeTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new Ns3WimaxSchedulingTestCase, TestCase::Duration::QUICK);
 }
 
 static Ns3WimaxQoSTestSuite ns3WimaxQoSTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/test/ss-mac-test.cc ns-3.42/src/wimax/test/ss-mac-test.cc
--- ns-3.41/src/wimax/test/ss-mac-test.cc	2024-02-09 14:44:08.625795400 -0800
+++ ns-3.42/src/wimax/test/ss-mac-test.cc	2024-05-29 15:29:47.228073800 -0700
@@ -166,10 +166,10 @@
 };
 
 Ns3WimaxSSMacTestSuite::Ns3WimaxSSMacTestSuite()
-    : TestSuite("wimax-ss-mac-layer", UNIT)
+    : TestSuite("wimax-ss-mac-layer", Type::UNIT)
 {
-    AddTestCase(new Ns3WimaxNetworkEntryTestCase, TestCase::QUICK);
-    AddTestCase(new Ns3WimaxManagementConnectionsTestCase, TestCase::QUICK);
+    AddTestCase(new Ns3WimaxNetworkEntryTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new Ns3WimaxManagementConnectionsTestCase, TestCase::Duration::QUICK);
 }
 
 static Ns3WimaxSSMacTestSuite ns3WimaxSSMacTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/test/wimax-fragmentation-test.cc ns-3.42/src/wimax/test/wimax-fragmentation-test.cc
--- ns-3.41/src/wimax/test/wimax-fragmentation-test.cc	2024-02-09 14:44:08.629795300 -0800
+++ ns-3.42/src/wimax/test/wimax-fragmentation-test.cc	2024-05-29 15:29:47.228073800 -0700
@@ -155,9 +155,9 @@
 };
 
 Ns3WimaxFragmentationTestSuite::Ns3WimaxFragmentationTestSuite()
-    : TestSuite("wimax-fragmentation", UNIT)
+    : TestSuite("wimax-fragmentation", Type::UNIT)
 {
-    AddTestCase(new Ns3WimaxFragmentationTestCase, TestCase::QUICK);
+    AddTestCase(new Ns3WimaxFragmentationTestCase, TestCase::Duration::QUICK);
 }
 
 static Ns3WimaxFragmentationTestSuite ns3WimaxFragmentationTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/test/wimax-service-flow-test.cc ns-3.42/src/wimax/test/wimax-service-flow-test.cc
--- ns-3.41/src/wimax/test/wimax-service-flow-test.cc	2024-02-09 14:44:08.629795300 -0800
+++ ns-3.42/src/wimax/test/wimax-service-flow-test.cc	2024-05-29 15:29:47.228073800 -0700
@@ -163,9 +163,9 @@
 };
 
 Ns3WimaxServiceFlowTestSuite::Ns3WimaxServiceFlowTestSuite()
-    : TestSuite("wimax-service-flow", UNIT)
+    : TestSuite("wimax-service-flow", Type::UNIT)
 {
-    AddTestCase(new Ns3WimaxSfCreationTestCase, TestCase::QUICK);
+    AddTestCase(new Ns3WimaxSfCreationTestCase, TestCase::Duration::QUICK);
 }
 
 static Ns3WimaxServiceFlowTestSuite ns3WimaxServiceFlowTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/test/wimax-tlv-test.cc ns-3.42/src/wimax/test/wimax-tlv-test.cc
--- ns-3.41/src/wimax/test/wimax-tlv-test.cc	2024-02-09 14:44:08.629795300 -0800
+++ ns-3.42/src/wimax/test/wimax-tlv-test.cc	2024-05-29 15:29:47.228073800 -0700
@@ -224,10 +224,10 @@
 };
 
 Ns3WimaxTlvTestSuite::Ns3WimaxTlvTestSuite()
-    : TestSuite("wimax-tlv", UNIT)
+    : TestSuite("wimax-tlv", Type::UNIT)
 {
-    AddTestCase(new Ns3WimaxCsParamTlvTestCase, TestCase::QUICK);
-    AddTestCase(new Ns3WimaxSfTlvTestCase, TestCase::QUICK);
+    AddTestCase(new Ns3WimaxCsParamTlvTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new Ns3WimaxSfTlvTestCase, TestCase::Duration::QUICK);
 }
 
 static Ns3WimaxTlvTestSuite ns3WimaxTlvTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/test.py ns-3.42/test.py
--- ns-3.41/test.py	2024-02-09 14:44:08.629795300 -0800
+++ ns-3.42/test.py	2024-05-29 15:29:47.228073800 -0700
@@ -169,10 +169,39 @@
     # can depend on ns3 configuration variables.  For example,
     # when NSC was in the codebase, we could write:
     #
-    #     ("tcp-nsc-lfn", "NSC_ENABLED == True", "NSC_ENABLED == False"),
+    #     ("tcp-nsc-lfn", "NSC_ENABLED == True", "NSC_ENABLED == False", "QUICK"),
     #
     cpp_examples = get_list_from_file(examples_to_run_path, "cpp_examples")
-    for example_name, do_run, do_valgrind_run in cpp_examples:
+    for cpp_example in cpp_examples:
+        # Old example specification did not include
+        # 'fullness', so for compatibility,
+        # allow 3 components, & set the 'fullness' to QUICK
+        if len(cpp_example) == 3:
+            example_name, do_run, do_valgrind_run = cpp_example
+            fullness = "QUICK"
+        elif len(cpp_example) == 4:
+            example_name, do_run, do_valgrind_run, fullness = cpp_example
+            fullness: str = fullness.upper()
+
+            if fullness != "QUICK" and fullness != "EXTENSIVE" and fullness != "TAKES_FOREVER":
+                raise ValueError(
+                    f"Invalid value provided for example '{example_name}' "
+                    + f"expected 'QUICK', 'EXTENSIVE', or 'TAKES_FOREVER', got: '{fullness}'"
+                )
+        else:
+            # If we have the name of the example we're error-ing for, provide it
+            # Otherwise, just give a generic message
+            if len(cpp_example) >= 1:
+                raise RuntimeError(
+                    f"Incorrect number of fields declaration of example '{cpp_example[0]}', "
+                    + f"expected 3, or 4 got: {len(cpp_example)}"
+                )
+            else:
+                raise RuntimeError(
+                    f"Incorrect number of fields declaration of example, "
+                    + f"expected 3, or 4 got: {len(cpp_example)}"
+                )
+
         # Separate the example name from its arguments.
         example_name_original = example_name
         example_name_parts = example_name.split(" ", 1)
@@ -200,12 +229,12 @@
                 example_name = "%s %s" % (example_name, example_arguments)
 
             # Add this example.
-            example_tests.append((example_name, example_path, do_run, do_valgrind_run))
+            example_tests.append((example_name, example_path, do_run, do_valgrind_run, fullness))
             example_names_original.append(example_name_original)
 
     # Each tuple in the Python list of examples to run contains
     #
-    #     (example_name, do_run)
+    #     (example_name, do_run, fullness)
     #
     # where example_name is the Python script to be run and
     # do_run is a condition under which to run the example.
@@ -213,10 +242,32 @@
     # Note that the condition is a Python statement that can
     # depend on ns3 configuration variables.  For example,
     #
-    #     ("brite-generic-example", "ENABLE_BRITE == True", "False"),
+    #     ("brite-generic-example.py", "ENABLE_BRITE == True", "QUICK"),
     #
     python_examples = get_list_from_file(examples_to_run_path, "python_examples")
-    for example_name, do_run in python_examples:
+    # Old example specification did not include
+    # 'fullness', so for compatibility,
+    # allow 2 components, & set the 'fullness' to QUICK
+    for python_example in python_examples:
+        if len(python_example) == 2:
+            example_name, do_run = python_example
+            fullness = "QUICK"
+        elif len(python_example) == 3:
+            example_name, do_run, fullness = python_example
+        else:
+            # If we have the name of the example we're error-ing for, provide it
+            # Otherwise, just give a generic message
+            if len(python_example) >= 1:
+                raise RuntimeError(
+                    f"Incorrect number of fields declaration of example '{python_example[0]}', "
+                    + f"expected 2, or 3 got: {len(python_example)}"
+                )
+            else:
+                raise RuntimeError(
+                    f"Incorrect number of fields declaration of example, "
+                    + f"expected 2, or 3 got: {len(python_example)}"
+                )
+
         # Separate the example name from its arguments.
         example_name_parts = example_name.split(" ", 1)
         if len(example_name_parts) == 1:
@@ -237,7 +288,7 @@
                 example_path = "%s %s" % (example_path, example_arguments)
 
             # Add this example.
-            python_tests.append((example_path, do_run))
+            python_tests.append((example_path, do_run, fullness))
 
 
 #
@@ -800,8 +851,8 @@
 # no longer needed.  If it is needed again in the future, define the
 # below variable again, and remove the alternative definition to None
 #
-# VALGRIND_SUPPRESSIONS_FILE = "testpy.supp"
-VALGRIND_SUPPRESSIONS_FILE = None
+VALGRIND_SUPPRESSIONS_FILE = ".ns3.supp"
+# VALGRIND_SUPPRESSIONS_FILE = None
 
 
 def run_job_synchronously(shell_command, directory, valgrind, is_python, build_path=""):
@@ -1657,7 +1708,7 @@
     if len(args.suite) == 0 and len(args.example) == 0 and len(args.pyexample) == 0:
         if len(args.constrain) == 0 or args.constrain == "example":
             if ENABLE_EXAMPLES:
-                for name, test, do_run, do_valgrind_run in example_tests:
+                for name, test, do_run, do_valgrind_run, fullness in example_tests:
                     # Remove any arguments and directory names from test.
                     test_name = test.split(" ", 1)[0]
                     test_name = os.path.basename(test_name)
@@ -1691,6 +1742,22 @@
                             if args.verbose:
                                 print("Queue %s" % test)
 
+                            if args.fullness == "QUICK" and fullness != "QUICK":
+                                job.set_is_skip(True)
+                                job.set_skip_reason(
+                                    f"skip {fullness} examples when QUICK run selected"
+                                )
+                            elif (
+                                args.fullness == "EXTENSIVE"
+                                and fullness != "EXTENSIVE"
+                                and fullness != "QUICK"
+                            ):
+                                job.set_is_skip(True)
+                                job.set_skip_reason(
+                                    f"skip {fullness} examples when EXTENSIVE run selected"
+                                )
+                            # TAKES_FOREVER includes everything, so no need to exclude anything
+
                             input_queue.put(job)
                             jobs = jobs + 1
                             total_tests = total_tests + 1
@@ -1755,7 +1822,7 @@
     #
     if len(args.suite) == 0 and len(args.example) == 0 and len(args.pyexample) == 0:
         if len(args.constrain) == 0 or args.constrain == "pyexample":
-            for test, do_run in python_tests:
+            for test, do_run, fullness in python_tests:
                 # Remove any arguments and directory names from test.
                 test_name = test.split(" ", 1)[0]
                 test_name = os.path.basename(test_name)
@@ -1797,6 +1864,20 @@
                         if args.verbose:
                             print("Queue %s" % test)
 
+                        if args.fullness == "QUICK" and fullness != "QUICK":
+                            job.set_is_skip(True)
+                            job.set_skip_reason(f"skip {fullness} examples when QUICK run selected")
+                        elif (
+                            args.fullness == "EXTENSIVE"
+                            and fullness != "EXTENSIVE"
+                            and fullness != "QUICK"
+                        ):
+                            job.set_is_skip(True)
+                            job.set_skip_reason(
+                                f"skip {fullness} examples when EXTENSIVE run selected"
+                            )
+                        # TAKES_FOREVER includes everything, so no need to exclude anything
+
                         input_queue.put(job)
                         jobs = jobs + 1
                         total_tests = total_tests + 1
@@ -1932,6 +2013,7 @@
                     f.write("  <Result>VALGR</Result>\n")
                 elif status == "SKIP":
                     f.write("  <Result>SKIP</Result>\n")
+                    f.write("  <Reason>%s</Reason>\n" % job.skip_reason)
                 else:
                     f.write("  <Result>CRASH</Result>\n")
 
@@ -2002,9 +2084,15 @@
                             post = contents.find("</Result>")
                             contents = contents[:pre] + "VALGR" + contents[post:]
                         f_to.write(contents)
-                        et = ET.parse(job.tmp_file_name)
-                        if et.find("Result").text in ["PASS", "SKIP"]:
-                            failed_jobs.pop()
+                        # When running with sanitizers, the program may
+                        # crash before ever writing the expected xml
+                        # output file
+                        try:
+                            et = ET.parse(job.tmp_file_name)
+                            if et.find("Result").text in ["PASS", "SKIP"]:
+                                failed_jobs.pop()
+                        except:
+                            pass
                 else:
                     with open(xml_results_file, "a", encoding="utf-8") as f:
                         f.write("<Test>\n")
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/utils/check-style-clang-format.py ns-3.42/utils/check-style-clang-format.py
--- ns-3.41/utils/check-style-clang-format.py	2024-02-09 14:44:08.629795300 -0800
+++ ns-3.42/utils/check-style-clang-format.py	2024-05-29 15:29:47.228073800 -0700
@@ -60,10 +60,12 @@
 DIRECTORIES_TO_SKIP = [
     "__pycache__",
     ".git",
+    ".venv",
     "bindings",
     "build",
     "cmake-cache",
     "testpy-output",
+    "venv",
 ]
 
 # List of files entirely copied from elsewhere that should not be checked,
@@ -80,51 +82,55 @@
 
 FILE_EXTENSIONS_TO_CHECK_INCLUDE_PREFIXES = FILE_EXTENSIONS_TO_CHECK_FORMATTING
 
-FILE_EXTENSIONS_TO_CHECK_WHITESPACE = [
+FILE_EXTENSIONS_TO_CHECK_TABS = [
     ".c",
     ".cc",
-    ".click",
     ".cmake",
-    ".conf",
     ".css",
-    ".dot",
-    ".gnuplot",
-    ".gp",
     ".h",
     ".html",
     ".js",
     ".json",
     ".m",
     ".md",
+    ".pl",
+    ".py",
+    ".rst",
+    ".sh",
+    ".toml",
+    ".yml",
+]
+
+FILES_TO_CHECK_TABS = [
+    ".clang-format",
+    ".clang-tidy",
+    ".codespellrc",
+    "CMakeLists.txt",
+    "codespell-ignored-lines",
+    "codespell-ignored-words",
+    "ns3",
+]
+
+FILE_EXTENSIONS_TO_CHECK_WHITESPACE = FILE_EXTENSIONS_TO_CHECK_TABS + [
+    ".click",
+    ".cfg",
+    ".conf",
+    ".dot",
+    ".gnuplot",
+    ".gp",
     ".mob",
     ".ns_params",
     ".ns_movements",
     ".params",
-    ".pl",
     ".plt",
-    ".py",
-    ".rst",
     ".seqdiag",
-    ".sh",
     ".txt",
-    ".yml",
 ]
 
-FILES_TO_CHECK_WHITESPACE = [
+FILES_TO_CHECK_WHITESPACE = FILES_TO_CHECK_TABS + [
     "Makefile",
-    "ns3",
 ]
 
-FILE_EXTENSIONS_TO_CHECK_TABS = [
-    ".c",
-    ".cc",
-    ".h",
-    ".md",
-    ".py",
-    ".rst",
-    ".sh",
-    ".yml",
-]
 TAB_SIZE = 4
 
 
@@ -141,9 +147,7 @@
 
     _, directory = os.path.split(dirpath)
 
-    return not (
-        directory in DIRECTORIES_TO_SKIP or (directory.startswith(".") and directory != ".")
-    )
+    return directory not in DIRECTORIES_TO_SKIP
 
 
 def should_analyze_file(
@@ -165,9 +169,9 @@
     if filename in FILES_TO_SKIP:
         return False
 
-    basename, extension = os.path.splitext(filename)
+    extension = os.path.splitext(filename)[1]
 
-    return basename in files_to_check or extension in file_extensions_to_check
+    return filename in files_to_check or extension in file_extensions_to_check
 
 
 def find_files_to_check_style(
@@ -220,7 +224,7 @@
         if should_analyze_file(f, FILES_TO_CHECK_WHITESPACE, FILE_EXTENSIONS_TO_CHECK_WHITESPACE):
             files_to_check_whitespace.append(f)
 
-        if should_analyze_file(f, [], FILE_EXTENSIONS_TO_CHECK_TABS):
+        if should_analyze_file(f, FILES_TO_CHECK_TABS, FILE_EXTENSIONS_TO_CHECK_TABS):
             files_to_check_tabs.append(f)
 
     return (
@@ -769,7 +773,9 @@
         print(e)
         sys.exit(1)
 
-    if all_checks_successful:
-        sys.exit(0)
-    else:
+    if not all_checks_successful:
+        if args.verbose:
+            print("")
+            print('NOTE: To fix the files automatically, run this script with the flag "--fix"')
+
         sys.exit(1)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/utils/codespell-ignored-lines ns-3.42/utils/codespell-ignored-lines
--- ns-3.41/utils/codespell-ignored-lines	2024-02-09 14:44:08.629795300 -0800
+++ ns-3.42/utils/codespell-ignored-lines	2024-05-29 15:29:47.228073800 -0700
@@ -81,10 +81,14 @@
  * Copyright (c) 2022 Universita' degli Studi di Napoli Federico II
  * Copyright (c) 2022 Universita' degli Studi di Napoli "Federico II"
  * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2024 Universita' degli Studi di Napoli Federico II
 
 ./src/core/examples/hash-example.cc
 6ed21de2  brand-newness       peripherial
 
+./src/core/model/trickle-timer.cc:120
+    return std::countr_zero(m_ticks);
+
 ./src/dsr/model/dsr-routing.cc:243, 246, 3360, 3363
             .AddAttribute("GratReplyHoldoff",
                           MakeTimeAccessor(&DsrRouting::m_gratReplyHoldoff),
@@ -161,3 +165,6 @@
   * (lte) Struct member `pfsFlowPerf_t::lastTtiBytesTrasmitted` in file `pf-ff-mac-scheduler.h` was renamed `fdbetsFlowPerf_t::lastTtiBytesTransmitted`.
 * The spelling of the attribute `IntialCellVoltage` from `LiIonEnergySource` was corrected to `InitialCellVoltage`; this will affect existing users who were using the attribute with the misspelling.
 * The attribute `Recievers` in class `YansWifiPhy` was misspelled, so this has been corrected to `Receivers`.
+
+./doc/manual/source/working-with-docker.rst
+    067a8b748816715d93ede9099132d943c04b13fcc23b3b8a7e21d23c1096cc2a
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/utils/codespell-ignored-words ns-3.42/utils/codespell-ignored-words
--- ns-3.41/utils/codespell-ignored-words	2024-02-09 14:44:08.629795300 -0800
+++ ns-3.42/utils/codespell-ignored-words	2024-05-29 15:29:47.228073800 -0700
@@ -26,6 +26,7 @@
 
 #Wi-Fi
 aci
+fils
 
 #Wimax
 aas
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/utils/create-module.py ns-3.42/utils/create-module.py
--- ns-3.41/utils/create-module.py	2024-02-09 14:44:08.629795300 -0800
+++ ns-3.42/utils/create-module.py	2024-05-29 15:29:47.228073800 -0700
@@ -214,10 +214,10 @@
 }};
 
 {CAPITALIZED}TestSuite::{CAPITALIZED}TestSuite()
-    : TestSuite("{MODULE}", UNIT)
+    : TestSuite("{MODULE}", Type::UNIT)
 {{
-    // TestDuration for TestCase can be QUICK, EXTENSIVE or TAKES_FOREVER
-    AddTestCase(new {CAPITALIZED}TestCase1, TestCase::QUICK);
+    // Duration for TestCase can be QUICK, EXTENSIVE or TAKES_FOREVER
+    AddTestCase(new {CAPITALIZED}TestCase1, TestCase::Duration::QUICK);
 }}
 
 // Do not forget to allocate an instance of this TestSuite
